// Muhammad Muddassir Malik

// A demonstration to use JSON for storing and loading settings and game scores

let circleScore = 0;
let squareScore = 0;
let fps = 1;

let fpsSlider;

let gameStorageJSON = {};

function preload(){
  gameStorageJSON = loadJSON("data/settings_score.json");
}

function setup() {
  createCanvas(500,500);
  
  fps = gameStorageJSON.fps;
  circleScore = gameStorageJSON.circleScore;
  squareScore = gameStorageJSON.squareScore;
  
  background(100);
  rectMode(CENTER);
  
  stroke(255, 255, 255);
  strokeWeight(3);
  line(width / 2, 0, width / 2, height);
  
  createP();
  createP();
  createP("Set game speed");
  fpsSlider = createSlider(1, 30, fps);
  createP();
  saveButton = createButton("Save Settings and Score");
  saveButton.mouseClicked(saveData);
}

function draw() {
  
  fps = fpsSlider.value();
  print(fps);
  frameRate(fps);  
    
  x = random(width);
  y = random(height - 150);
  if (x < width / 2){
    noFill();
    stroke(255, 255, 255);
    fill(255, 50, 50);
    ellipse(x, y, 30, 30);
    
    circleScore++;
  }
  
  x = random(width);
  y = random(height - 150);
  
  if (x > width / 2){
    noFill();
    stroke(255, 255, 255);
    fill(50, 255, 50);
    rect(x, y, 30, 30);
    
    squareScore++;
  }
  print(circleScore, squareScore);
  
  fill(255, 255, 255);
  rect(width / 2, 460, 400, 70);
  
  textAlign(CENTER);
  noStroke();
  fill(0, 0, 0);
  textSize(40);
  let winnerName = " no one";
  if (circleScore > squareScore){
    winnerName = " Circles";
  } else if ( squareScore > circleScore ) {
    winnerName = " Squares";
  }
    
  text("Winner:" + winnerName, 250,480);
  fill(255, 0, 0);
  text(circleScore, 80, 460);
  fill(0, 255, 0);
  text(squareScore, 420, 460);
}

function saveData(){
  gameStorageJSON.fps = fps;
  gameStorageJSON.circleScore = circleScore;
  gameStorageJSON.squareScore = squareScore;
  saveJSON(gameStorageJSON, "settings_score.json");
}
