
// Craig S. Kaplan

// A demonstration of downloading a live RSS feed from the internet
// (in this case, the RSS feed for the podcast Radiolab) and displaying
// its information.  The RSS feed is converted in real time from its
// native XML format to JSON using a third-party service (rss2json.com).

// import controlP5.*;

let feed;        // JSON Object
let num_items;
let current;
let img;

// ControlP5 ui;
// Textarea title;
// Textarea desc;

function preload(){
  feed = loadJSON( "https://api.rss2json.com/v1/api.json?rss_url=http%3A%2F%2Ffeeds.wnyc.org%2Fradiolab%3Fformat%3Dxml");
}

function setup() {
  noCanvas(); //createCanvas( 570, 300 );
  num_items = feed.items.length;
  current = 1;
  setCurrent( 0 );
  
  print(num_items);
  print(feed);
}

function draw() {
  
}

function setCurrent( n ) {
  if ( current != n ) {
    removeElements();
    current = n;
    obj = feed.items[n];
    
    title = createElement("h1", obj.title);
    createP();
    img = createImg(obj.thumbnail, "Image missing");
    createP();
    createP(obj.description);
  }
}

function keyPressed() {
  if ( keyCode == RIGHT_ARROW ) {
    setCurrent( min( current + 1, num_items - 1 ) );
  } else if ( keyCode == LEFT_ARROW ) {
    setCurrent( max( current - 1, 0 ) );
  }
}
